<?php

print("<?xml version='1.0' encoding='utf-8'?>");

$user="turnonred";

$loc_path="";

// INDEX MACHINE

    // 1. Include FSDLRequest class

	include_once('FsdlRequestParser.php');	// The file should be located outside the server's document root

/*
	// 2. Check server request method - I'm not using this here because the first time the
                                        //slide is opened, there is no server request 
		
	$serverRequestMethod = $_SERVER['REQUEST_METHOD'];

	if ($serverRequestMethod != 'POST')	// This should never occur when navigating this sample Frogans site
	{
		exit(1);
	}
*/		
	
	// 3. Get content of HTTP body received by server
	
	$serverRequestBody = file_get_contents("php://input");


	// 4. Create and initialize $fsdlRequest

	$fsdlRequest = new FsdlRequest();

	$fsdlRequestDocumentVersion = FSDLRequestDocumentVersion::VERSION_3_0;
	$receivedDocument = $serverRequestBody;
	$errorMessage = "";
	
	$result = $fsdlRequest->initialize($fsdlRequestDocumentVersion, $receivedDocument, $errorMessage);


	// 5. Get all available data from $fsdlRequest

    $fileFields = $fsdlRequest->getFileFields();					
					//	Value is applicable only if $fsdlRequestWanted is FsdlRequestWanted::FSDL_DOCUMENT
					//									and $fsdlRequestNavigation is not FsdlRequestNavigation::OPEN
					//						  or if $fsdlRequestWanted is FsdlRequestWanted::AUXILIARY_FILE
					//	If not applicable, value is an empty array.
					//	If applicable, value is an array of up to FsdlRequest::FILE_FIELDS_COUNT_MAX key-value pairs.
					//	The array can be empty.
                    

$limit = 20;
$limitLess = $limit-1;
   
	
	if ($result == FALSE)	// this will happen the first time the slide is opened. Here we want the color to be black.
	{
		$mindex=0;
        echo "<!-- false -->";
	}else{

        $mindex=$fileFields['myindex']; 
        if($mindex>$limitLess){
            $mindex -= $limit; //that way it loops
        }elseif($mindex<0){
            $mindex += $limit;
        }
   }

echo "<!-- mindex= $mindex -->";


$index=$mindex;

// START get all the info from Twitter

$rss = new DOMDocument();
$rss->load("https://twitrss.me/twitter_user_to_rss/?user=$user");
$feed = array();
foreach ($rss->getElementsByTagName('item') as $node) {
    $item = array ( 
        'title' => $node->getElementsByTagName('title')->item(0)->nodeValue,
        'desc' => $node->getElementsByTagName('description')->item(0)->nodeValue,
        'link' => $node->getElementsByTagName('link')->item(0)->nodeValue,
        'date' => $node->getElementsByTagName('pubDate')->item(0)->nodeValue,
        );
    array_push($feed, $item);
}



$my_title=$feed[$index]['title'];
$my_desc=$feed[$index]['desc'];
$my_linkToPage=$feed[$index]['link'];
$my_date=$feed[$index]['date'];

//a regular expression finds a url in the tweet text
$reg_exUrl = "/(?i)\b((?:https?:\/\/|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'\".,<>?«»“”‘’]))/";
$link = preg_match_all($reg_exUrl, $my_title, $match);

$linkLong=$match[0][0]; // $match is the array that contains the link we want
$pos = strpos($linkLong, "…");
$picPos=strpos($my_title,"pic.twitter.com");

//Test to verify the link is really a link
$link_start=substr($linkLong,0,4);

if ($link_start != "http"){
    $linkLong=NULL;
}


$linkShort=substr($linkLong,0,$pos-2); // This is the good link. gotta shorten the link because the ... is added after it.

if($picPos){
    $titleShort=substr($my_title,0,$picPos);
    include('imagemag.php');
}else{
    $titleShort=$my_title;
    }
    

 // END get info from Twitter

    function EscapeFieldValue($value)		// Escape "&", "<" and " " characters in a field value to be displayed
	{
		$tmp = str_replace("&", "&amp;", $value);
		$tmp = str_replace("<", "&lt;", $tmp);
		$tmp = str_replace(" ", "&#xA0;", $tmp);
        //$tmp = str_replace("�", "&#xA0;", $tmp);
		return $tmp;
	}
//Find the domain name and replace the URL with it in the tweet
$link_parsed=parse_url($linkShort);

$link_domain=$link_parsed['host']; // gets the host domain.
$link_domain_null=NULL; // put that in the text to get rid of host domain 

//let's replace the link with the domain name, and in bold text
if($linkLong){
    $pos_link = strpos($titleShort, $linkShort);
    $length_link=strlen($linkShort)+1;
    $pos_end_link=$pos_link + $length_link;
    //$title_wBold=EscapeFieldValue($title_wBold);
    $title_wBold=substr_replace($titleShort, "</text><text fontref='bold_fnt' join='space'>".$link_domain_null."</text><text join='space' >", $pos_link, $pos_end_link);
}else{
    $title_wBold=$titleShort;
}

?>

<frogans-fsdl version='3.0'>

<!--FONTS -->

<setfont fontid='reg_fnt' >
        <font scripts='default' pfont='110-1-mono-r' height='10' color='#000000' spacing='0' />
    </setfont> 

<setfont fontid='bold_fnt' >
        <font scripts='default' pfont='110-2-mono-b' height='10' color='#000000' spacing='0' />
    </setfont> 

<setfont fontid='redlink_fnt' >
        <font scripts='default' pfont='110-2-mono-b' height='10' color='#ee0000' spacing='0' />
    </setfont> 

<setfont fontid='date_fnt' >
        <font scripts='default' pfont='110-1-mono-r' height='8.5' color='#000000' spacing='0' xitalic='50' 
         />
    </setfont> 


<!--FILTERS -->
<setfilter filterid='b_hue' >
    <filter effect='hue' angle='-95' />
</setfilter>

<setfilter filterid='desat' >
    <filter effect='saturation' level='-100' />
</setfilter>



<!--NAV FILES -->
<file fileid='home_f' nature='static' name='<? echo $loc_path; ?>/home.php' />


<!-- images -->
<file fileid='bk_f' nature='static' name='<? echo $loc_path; ?>/bkg.png' />
<resimage fileref='bk_f' resid='bk_r' size='640,480' />
<layer resref='bk_r' layerid='bk_l' pos='320,240' align='center-middle' combine='add' leapout='lead' />

<file fileid='vig_f' nature='static' name='<? echo $loc_path; ?>/vig.png' />
<resimage fileref='vig_f' resid='vig_r' size='640,480' />
<layer resref='vig_r' layerid='vig_l' pos='320,240' align='center-middle' combine='add' leapout='vignette' />

<?

$picPath=$loc_path."/".$thumbname;

$img_layer="resref='image_r'  align='center-middle' 
    pos='320,280'";

if($picPos){
    echo "
<file fileid='image_f' nature='static' name='$picPath' />
<resimage fileref='image_f' resid='image_r' size='600,260' />

<layer layerid='image_trans_l' $img_layer leapout='lead' combine='clip' opacity='20' />

<!-- <layer layerid='image_vig_l' resref='image_r'  align='center-middle' 
    pos='320,240' leapout='vignette' combine='add' opacity='100' />  -->

";
}

?>
<?
//The timestamp format
$time_format="M d, Y g:ia";
date_default_timezone_set('Europe/Paris');

// Find how much time has elapsed since now()
// from: https://stackoverflow.com/a/18602474/235633
//
function timeElapsedSinceNow( $datetime, $full = false )
{
    $now = new DateTime;
    $then = new DateTime( $datetime );
    $diff = (array) $now->diff( $then );

    $diff['w']  = floor( $diff['d'] / 7 );
    $diff['d'] -= $diff['w'] * 7;

    $string = array(
        'y' => 'year',
        'm' => 'month',
        'w' => 'week',
        'd' => 'day',
        'h' => 'hour',
        'i' => 'min',
        's' => 'sec',
    );

    foreach( $string as $k => & $v )
    {
        if ( $diff[$k] )
        {
            $v = $diff[$k] . ' ' . $v .( $diff[$k] > 1 ? 's' : '' );
        }
        else
        {
            unset( $string[$k] );
        }
    }

    if ( ! $full ) $string = array_slice( $string, 0, 1 );
    return $string ? implode( ', ', $string ) . ' ago' : 'just now';
}

$my_date_mod=timeElapsedSinceNow( $my_date, $full = false );

?>

<!-- TEXT -->
<restext resid='tweet_t_r' size='522,262' orientation='h-ttb-ltr' fontref='reg_fnt' talign='begin' linespace='15' >
    <text fontref='date_fnt' linespace='50' ><? echo $my_date_mod; ?></text>
    <text><? echo $title_wBold; ?></text>
</restext>
<layer resref='tweet_t_r' layerid='tweet_t_l' pos='57,134' align='left-top' combine='add' leapout='lead' />

<!-- BUTTONS -->

<resimage fileref='bk_f' resid='pic_r' size='60,57' selection='extract' bounds='213,413,273,470' />
<resimage fileref='bk_f' resid='link_r' size='60,57' selection='extract' bounds='287,413,347,470' />
<resimage fileref='bk_f' resid='tweb_r' size='60,57' selection='extract' bounds='360,413,420,470' />
<resimage fileref='bk_f' resid='rssweb_r' size='123,41' selection='extract' bounds='485,403,608,444' />
<resimage fileref='vig_f' resid='dial_r' size='86,86'  />

<?
$next_index=$mindex+1;
$prev_index=$mindex-1;
?>


<setdata dataid='prev_dat'>
        <data key='myindex'><? echo $prev_index ?></data>
    </setdata>
    <file fileid='prev_f' nature='dynamic' name='<? echo $loc_path; ?>/home.php' dataref='prev_dat' />

    <setdata dataid='next_dat'>
        <data key='myindex'><? echo $next_index ?></data>
    </setdata>
    <file fileid='next_f' nature='dynamic' name='<? echo $loc_path; ?>/home.php' dataref='next_dat' />

    <setdata dataid='first_dat'>
        <data key='myindex'>0</data>
    </setdata>
    <file fileid='first_f' nature='dynamic' name='<? echo $loc_path; ?>/home.php' dataref='first_dat' />


  <next delay='300' fileref='first_f' /> 


<!-- prev -->
<button buttonid='prev_b' goto='slide'  fileref='prev_f' >
    <layer resref='dial_r' layerid='prev_l' leapout='lead' combine='add' align='left-top' 
    pos='41,0' visible='always' flip='xdir' />
    <layer resref='dial_r' layerid='prev_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='41,0' visible='selected' flip='xdir' filterref='b_hue'  />
</button>

<!-- next -->
<button buttonid='next_b' goto='slide'  fileref='next_f' >
    <layer resref='dial_r' layerid='next_l' leapout='lead' combine='add' align='left-top' 
    pos='517,0' visible='always'  />
    <layer resref='dial_r' layerid='next_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='517,0' visible='selected' filterref='b_hue'  />
</button>


<!-- pic -->

<? 


$picBtn="

<button buttonid='pic_b' goto='way-out' uri='$image_url' >
    <layer resref='pic_r' layerid='pic_l' leapout='lead' combine='add' align='left-top' 
    pos='213,413' visible='always'/>
    <layer resref='pic_r' layerid='pic_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='213,413' visible='selected' filterref='b_hue'  />
    <layer layerid='imgage_l' $img_layer combine='clip' leapout='lead' visible='selected'  />
</button>
";

if($picPos){
    echo $picBtn;

}else{
    echo"
    <layer resref='pic_r' layerid='pic_l' leapout='lead' combine='add' align='left-top' 
    pos='213,413' filterref='desat' />
    ";
}

?>

<!-- link -->

<resdraw resid='under_btex_r' figure='roundrect' size='500,80' round='20,20' stroke='off' color='#ffffff' />

<? 
$linkShort=EscapeFieldValue($linkShort);

$linkBtn="

<restext resid='url_t_r' size='520,60' orientation='h-ttb-ltr' fontref='redlink_fnt' talign='center'  >
<!--    <text>$linkShort</text>     -->
    <text fontref='reg_fnt'>More on</text
    ><text >$link_domain</text>

</restext>
<button buttonid='link_b' goto='way-out' uri='$linkShort' >
    <layer resref='under_btex_r' layerid='under_btex_l' leapout='lead' combine='clip' align='center-top' 
    pos='320,325' visible='selected' blur='10,6' />
    <layer resref='link_r' layerid='link_l' leapout='lead' combine='add' align='left-top' 
    pos='287,413' visible='always'/>
    <layer resref='link_r' layerid='link_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='287,413' visible='selected' filterref='b_hue'  />
    <layer resref='url_t_r' layerid='url_t_l' leapout='lead' combine='clip' align='center-top' 
    pos='320,340' visible='selected'  filterref='b_hue' />
</button>

";

if($linkShort){
    echo $linkBtn;

}else{
    echo"
    <layer resref='link_r' layerid='link_l' leapout='lead' combine='add' align='left-top' 
    pos='287,413' filterref='desat' />
    ";
}

?>


<!-- tweb -->

<resdraw resid='under_btex2_r' figure='roundrect' size='200,40' round='20,20' stroke='off' color='#ffffff' />

<restext resid='tweb_t_r' size='550,80' orientation='h-ttb-ltr' fontref='redlink_fnt' talign='center'  >
    <text>twitter.com</text>
</restext>
<button buttonid='tweb_b' goto='way-out' uri='<? echo $my_linkToPage; ?>' >
    <layer resref='under_btex2_r' layerid='under_btex2_l' leapout='lead' combine='clip' align='center-top' 
    pos='320,360' visible='selected' blur='10,6' />
    <layer resref='tweb_r' layerid='tweb_l' leapout='lead' combine='add' align='left-top' 
    pos='360,413' visible='always'/>
    <layer resref='tweb_r' layerid='tweb_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='360,413' visible='selected' filterref='b_hue'  />
    <layer resref='tweb_t_r' layerid='tweb_t_l' leapout='lead' combine='clip' align='center-top' 
    pos='320,370' visible='selected' filterref='b_hue'  />
</button>

<!-- tweb -->
<button buttonid='rssweb_b' goto='way-out' uri='https://twitrss.me/' >
    <layer resref='rssweb_r' layerid='rssweb_l' leapout='lead' combine='clip' align='left-top' 
    pos='485,403' visible='always' />
    <layer resref='rssweb_r' layerid='rssweb_o_l' leapout='lead' combine='clip' align='left-top' 
    pos='485,403' visible='selected' filterref='b_hue'  />
</button>


</frogans-fsdl>
